/*
 * $Id: ViewUtils.js,v 1.35.2.1 2005/06/15 09:42:32 kps Exp $
 */

//Currently we are allowing some functions to override useSubRequest
//This is a temporary fix done for fixing issues.
var showError=true;
var useSubRequest=false;
 
function refreshCurrentView()
{ 
  openURL(getViewURL(ROOT_VIEW_ID));
}

function openURL(url,windowname,windowparams)
{
  url = updateStateCookieAndAppendSid(url);
  if((!windowname) || (windowname == ""))
  {
      windowname="_self";
  }

  if(windowname == "_self")
  {

     window.location.href=url; 
  }
  else
  {
     window.open(url,windowname,windowparams);
  }
}

function handleEvent(actionSource,eventParams,refreshLevel)
{
   var actionURL = actionSource + ".ve";
   actionURL += "?" + eventParams;
   processURLBasedOnLevel(actionURL,actionSource,refreshLevel);
}


//Unnecessarly complex impl!!
function processURLBasedOnLevel(url,id,refreshLevel)
{
	var viewUniqueId = getUniqueId(id);
	if(refreshLevel == -1)
	{    
           if(window.location.href.indexOf("STATE_ID") > -1)
           {       
               handleSubRequest(url,parent.ROOT_VIEW_ID);
           }
           else
           {
              openURL(url);
           }
	}
	else if(refreshLevel == 0)
	{
	   handleSubRequest(url,viewUniqueId,true);
	}
	else
	{
		var viewToRefresh = viewUniqueId;
		for(var i = 0; i < refreshLevel; i++)
		{
			viewToRefresh = getUniqueId(stateData[viewToRefresh]["_PV"]);
			if(viewToRefresh == null)
			{
				break;
			}
		}
		if((viewToRefresh == ROOT_VIEW_ID) || (viewToRefresh == null))
		{
			openURL(url);
		}
		else
		{
			handleSubRequest(url,viewToRefresh,true);
		}
	}
}


function refreshSubView(id,useOldState)
{
    var viewUniqueId = getUniqueId(id);
    var resFrame = parent.frames[parent.ROOT_VIEW_ID + "_RESPONSEFRAME"];
    var viewUrl = getViewURL(viewUniqueId);
    handleSubRequest(viewUrl,viewUniqueId,true,useOldState);
}

function handleSubRequest(reqUrl,rootViewId,override,useOldState)
{
    if(useSubRequest || override)
    {
       if(!useOldState)
       {
          reqUrl = updateStateCookieAndAppendSid(reqUrl,rootViewId);
       } 
       reqUrl = appendSubRequestArgs(reqUrl);
       window.frames[parent.ROOT_VIEW_ID + "_RESPONSEFRAME"].location.href = reqUrl;
    }
    else
    {
       openURL(reqUrl);
    }
}



function appendSubRequestArgs(reqUrl)
{
  return getURLSuffixed(reqUrl) + "SUBREQUEST=true";
}


function getViewURL(id)
{
  var uniqueId = getUniqueId(id);
  var viewUrl = stateData[uniqueId]["_VN"] + ".cc?UNIQUE_ID=" + uniqueId;
  var params = stateData[uniqueId]["_D_RP"];
  if(params != null)
  {
    params = params;
    viewUrl += "&" + params;
  }
  return viewUrl;
}

function addRequestParams(id, reqParams)
{
	var uniqueId = getUniqueId(id);
  if(reqParams == null)
  {
    return; 
  }
  var params = stateData[uniqueId]["_D_RP"];
  if(params != null)
  {
    params = params + "&" + reqParams;
  }
  else 
  {
    params = reqParams;
  }
  stateData[uniqueId]["_D_RP"] = params;
}


//------------ Response Handling --------------------------------

function updateTimeToLoad(timeToLoad,win)
{

   var timeEl = win.document.getElementById("timeToLoad");
   if(!timeEl)
   {
      timeEl = parent.document.getElementById("timeToLoad");     
   }
   
   if(timeEl == null)
   {
      var str = "Time taken to load : <span id='timeToLoad'>" + timeToLoad + "</span>ms";
      var spEl = parent.document.createElement("span");
      spEl.className = "timeToLoad";
      spEl.innerHTML = str;
      parent.document.body.appendChild(spEl);
   }
   else
   {
      timeEl.innerHTML = "" + timeToLoad;
   }
   
}


/**
* This API can be used for refreshing views. 
* Note : This schedules the view only once if rescheduleInterval is not
* given.
**/
function scheduleViewForRefresh(id,initSchedTime,reScheduleInterval)
{
  var viewUniqueId = getUniqueId(id);
  if(!parent._RSC)
  {
    _RSC=new Object();
  }
  if(_RSC[viewUniqueId] != null)
  {
     return;
  } 
  if(!reScheduleInterval)
  {
    reScheduleInterval = -1;
  }
  _RSC[viewUniqueId]= reScheduleInterval;
  setTimeout("refreshScheduled('" + viewUniqueId + "')",initSchedTime);
}



/**
 * This is an internal API used by scheduleViewForRefresh.
 **/
function refreshScheduled(viewUniqueId)
{
   if(isViewVisible(viewUniqueId))
   {
     refreshSubView(viewUniqueId,true);   
   }
   if(_RSC[viewUniqueId] == -1)
   {
     _RSC[viewUniqueId] = null;
   }
   else
   {
     setTimeout("refreshScheduled('" + viewUniqueId + "')",_RSC[viewUniqueId]);    
   } 
}


function createForm(action,target,method,name)
{
  var newFrm = document.createElement("form");
  setAttrOnFrm(newFrm,"name",name);
  setAttrOnFrm(newFrm,"method",method);
  setAttrOnFrm(newFrm,"target",target);
  setAttrOnFrm(newFrm,"action",action);
  return newFrm;
}

function setAttrOnFrm(frm,attrName,attrValue)
{
  if(attrValue != null)
  {
    frm.setAttribute(attrName,attrValue);
  }
}

function addHiddenInput(frm,name,value)
{
  var newElement = document.createElement("input");
  newElement.setAttribute("type","hidden");
  newElement.setAttribute("name",name);
  newElement.setAttribute("value",value);
  frm.appendChild(newElement);
}

function submitFormAsSubReq(frm,target,actionSrc,rootViewId)
{

  if(rootViewId == null)
  {
     //Wrong - Should have been ROOTVIEWID
     rootViewId = actionSrc;
  }
  handleStateForForm(frm,actionSrc,rootViewId,true,target);
  document.body.appendChild(frm);
  frm.submit();
}


function isViewVisible(uniqueId)
{
   return document.getElementById(uniqueId + "_CT") != null;  
}

function isViewStateNeeded(uniqueId)
{
   if(isViewVisible(uniqueId))
   {
      return true;
   }

   var dac = getContentAreaFromState(uniqueId);
   if(dac != null)
   {
       alert(uniqueId + " " + dac);
       return true;
   }
}




/*
* Note : This method does not remove the state for the view.
*/
function  replaceView(viewToReplace,replacingView)
{
    var replacedEl = document.getElementById(viewToReplace + "_CT");
    if(replacedEl == null) 
    {
       alert("The html content for viewToReplace arg ("+ viewToReplace +") passed is not present");
       return;
    }
    oldViews[viewToReplace] = replacedEl;
    if(oldViews[replacingView] == null)
    {
       alert("The html content for replacingView ("+ replacingView +") passed is not present in the client cache"); 
       return;
    }
    replacedEl.parentNode.replaceChild(oldViews[replacingView],replacedEl);
}


function showMsgInWindow(winName,message)
{
  var msgWindow = window.open("about:blank","_blank","width=300,height=300,resizable=yes");
  //var el = msgWindow.document.createElement("div");
  //el.innerHTML = message;
  //msgWindow.document.body.appendChild(el);
  msgWindow.document.writeln(message);
}

